/*******************************************************************************
**
** SPECIFICATION VERSION:
**   SAIM-AIS-R2-JD-A.01.01
**   SAI-Overview-B.01.01
**   SAI-AIS-AMF-B.01.01
**
** DATE:
**   Wed Aug 6 2008
**
** LEGAL:
**   OWNERSHIP OF SPECIFICATION AND COPYRIGHTS.
**
** Copyright 2008 by the Service Availability Forum. All rights reserved.
**
** Permission to use, copy, and distribute this mapping specification for any
** purpose without fee is hereby granted, provided that this entire notice
** is included in all copies. No permission is granted for, and users are
** prohibited from, modifying or making derivative works of the mapping
** specification.
**
*******************************************************************************/

package org.saforum.ais.amf;


/**
 * The CsiStateDescriptor type holds additional information about the
 * assignment of a component service instance to a component when the component
 * is requested to assume the active or standby HA state for this component
 * service instance.
 *
 * <P><B>SAF Reference:</B> <code>SaAmfCSIStateDescriptorT</code>
 * @version AMF-B.01.01 (SAIM-AIS-R2-JD-A.01.01)
 * @since AMF-B.01.01
 * @see CsiActiveDescriptor
 * @see CsiStandbyDescriptor
 */
public abstract class CsiStateDescriptor {
}


